/**
 * request 网络请求工具
 * 更详细的 api 文档: https://github.com/umijs/umi-request
 */
import {extend} from 'umi-request';
import Common from "@/utils/Common";

const codeMessage = {
  200: '服务器成功返回请求的数据。',
  201: '新建或修改数据成功。',
  202: '一个请求已经进入后台排队（异步任务）。',
  204: '删除数据成功。',
  400: '发出的请求有错误，服务器没有进行新建或修改数据的操作。',
  401: '用户没有权限（令牌、用户名、密码错误）。',
  403: '用户得到授权，但是访问是被禁止的。',
  404: '发出的请求针对的是不存在的记录，服务器没有进行操作。',
  406: '请求的格式不可得。',
  410: '请求的资源被永久删除，且不会再得到的。',
  422: '当创建一个对象时，发生一个验证错误。',
  500: '服务器发生错误，请检查服务器。',
  502: '网关错误。',
  503: '服务不可用，服务器暂时过载或维护。',
  504: '网关超时。',
};

/**
 * 保存用户登录信息
 */
export const saveLoginInfo = (data) => {
  sessionStorage.setItem('token', data.token);
  sessionStorage.setItem('nickName', data.user.nickName);
};


/**
 * 异常处理程序
 */
const errorHandler = error => {
  const {response} = error;
  let res = {
    code: -1,
    message: '请求初始化时出错或者服务器没有响应返回'
  };

  if (!Common.isEmpty(response)) {
    res.code = response.status;
    res.message = codeMessage[response.status] || response.statusText;
  }

  return res;
};
/**
 * 配置request请求时的默认参数
 */

const request = extend({
  errorHandler,
  // 默认错误处理
  credentials: 'include', // 默认请求是否带上cookie
  requestType: "json", // 表单提交post请求
});

request.use((async (ctx, next) => {
  const {options} = ctx.req;

  options.headers = {...options.headers, token: sessionStorage.getItem('token')};

  // 存在分页器的时候
  if (options.params?.pagination) {
    options.params.length = options.params.pagination.pageSize;
    options.params.start = options.params?.length * (options.params.pagination.current - 1);
    delete options.params['pagination'];
  }
  if (options.data?.pagination) {
    options.data.length = options.data.pagination.pageSize;
    options.data.start = options.data.length * (options.data.pagination.current - 1);
    delete options.data['pagination'];
  }

  // equals 处理
  if (options.params && options.params.equals) {
    let ids = [];
    let equalsObj = options.params.equals;
    Object.keys(equalsObj).map(key => {
      if (!Common.isEmpty(equalsObj[key])) {
        ids.push(key + "=" + equalsObj[key]);
      }
    });
    options.params.equals = ids.join(",");
  }

// 增加通用参数

  await next();

}));


export default request;
